/*
 * Marcin Owsiany 8:00
 * 3 18.11.2000
 * 2 6
 */

#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <time.h>

#define TSIZE 5000

struct stat st1, st2;
int n, f, fn;
char buff[TSIZE];

int do_copy()
{
	struct tm *loctm;
	printf("Copying\n");
	loctm = localtime(&st2.st_mtime);
	strftime(buff+8+fn+1+fn, TSIZE, ".%d-%m-%Y.%H:%M:%S", loctm);
	system(buff);
	return 1;
}

int main(int argc, char *argv[])
{
	char *foo;
	if (argc != 3) {
		fprintf(stderr, "Wrong number of options\n");
		exit(EXIT_FAILURE);
	}
	if (stat(argv[1], &st1) == -1) {
		perror(argv[1]);
		exit(EXIT_FAILURE);
	}
	foo = malloc(strlen(argv[2]));
	n = strtol(argv[2], &foo, 10);
	if (*foo != '\0') {
		fprintf(stderr, "Wrong number: %s\n", argv[2]);
		exit(EXIT_FAILURE);
	}
	fn = strlen(argv[1]);
	if (fn > 4000) {
		fprintf(stderr, "Za dluga nazwa pliku\n");
		exit(EXIT_FAILURE);
	}
	strcpy(buff, "/bin/cp ");
	strcpy(buff+8, argv[1]);
	strcpy(buff+8+fn, " ");
	strcpy(buff+8+fn+1, argv[1]);
	f = open(argv[1], O_RDONLY);
	while (1) {
		if (fstat(f, &st2) == -1) {
			perror(argv[1]);
			exit(EXIT_FAILURE);
		}
		if ((st1.st_size  != st2.st_size)
		 || (st1.st_mtime != st2.st_mtime))
			if (! do_copy()) {
				printf("Error copying\n");
				exit(EXIT_FAILURE);
			}
		st1 = st2;
		sleep(n);
	}
	exit(EXIT_FAILURE);
}
